diff --git a/drivers/platform/chrome/cros_ec_proto.c b/drivers/platform/chrome/cros_ec_proto.c
index 5f4414f05d66..07b57ea105b6 100644
--- a/drivers/platform/chrome/cros_ec_proto.c
+++ b/drivers/platform/chrome/cros_ec_proto.c
@@ -400,7 +400,7 @@ static int fill_protocol_info_legacy(struct cros_ec_device *ec_dev)
 }
 
 /*
- * cros_ec_get_host_command_version_mask
+ * get_host_command_version_mask
  *
  * Get the version mask of a given command.
  *
@@ -415,16 +415,14 @@ static int fill_protocol_info_legacy(struct cros_ec_device *ec_dev)
  * the caller has ec_dev->lock mutex or the caller knows there is
  * no other command in progress.
  */
-static int cros_ec_get_host_command_version_mask(struct cros_ec_device *ec_dev,
-	u16 cmd, u32 *mask)
+static int get_host_command_version_mask(struct cros_ec_device *ec_dev, u16 cmd, u32 *mask)
 {
 	struct ec_params_get_cmd_versions *pver;
 	struct ec_response_get_cmd_versions *rver;
 	struct cros_ec_command *msg;
 	int ret;
 
-	msg = kmalloc(sizeof(*msg) + max(sizeof(*rver), sizeof(*pver)),
-		      GFP_KERNEL);
+	msg = kmalloc(sizeof(*msg) + max(sizeof(*rver), sizeof(*pver)), GFP_KERNEL);
 	if (!msg)
 		return -ENOMEM;
 
@@ -443,7 +441,6 @@ static int cros_ec_get_host_command_version_mask(struct cros_ec_device *ec_dev,
 	}
 
 	kfree(msg);
-
 	return ret;
 }
 
@@ -488,21 +485,16 @@ int cros_ec_query_all(struct cros_ec_device *ec_dev)
 		return -ENOMEM;
 
 	/* Probe if MKBP event is supported */
-	ret = cros_ec_get_host_command_version_mask(ec_dev,
-						    EC_CMD_GET_NEXT_EVENT,
-						    &ver_mask);
-	if (ret < 0 || ver_mask == 0)
+	ret = get_host_command_version_mask(ec_dev, EC_CMD_GET_NEXT_EVENT, &ver_mask);
+	if (ret < 0 || ver_mask == 0) {
 		ec_dev->mkbp_event_supported = 0;
-	else
+	} else {
 		ec_dev->mkbp_event_supported = fls(ver_mask);
-
-	dev_dbg(ec_dev->dev, "MKBP support version %u\n",
-		ec_dev->mkbp_event_supported - 1);
+		dev_dbg(ec_dev->dev, "MKBP support version %u\n", ec_dev->mkbp_event_supported - 1);
+	}
 
 	/* Probe if host sleep v1 is supported for S0ix failure detection. */
-	ret = cros_ec_get_host_command_version_mask(ec_dev,
-						    EC_CMD_HOST_SLEEP_EVENT,
-						    &ver_mask);
+	ret = get_host_command_version_mask(ec_dev, EC_CMD_HOST_SLEEP_EVENT, &ver_mask);
 	ec_dev->host_sleep_v1 = (ret >= 0 && (ver_mask & EC_VER_MASK(1)));
 
 	/* Get host event wake mask. */
diff --git a/drivers/platform/chrome/cros_ec_proto_test.c b/drivers/platform/chrome/cros_ec_proto_test.c
index 22f9322787f4..e2c369765612 100644
--- a/drivers/platform/chrome/cros_ec_proto_test.c
+++ b/drivers/platform/chrome/cros_ec_proto_test.c
@@ -217,7 +217,7 @@ static void cros_ec_proto_test_query_all_normal(struct kunit *test)
 		data->max_request_packet_size = 0xbf;
 	}
 
-	/* For cros_ec_get_host_command_version_mask() for MKBP. */
+	/* For get_host_command_version_mask() for MKBP. */
 	{
 		struct ec_response_get_cmd_versions *data;
 
@@ -228,7 +228,7 @@ static void cros_ec_proto_test_query_all_normal(struct kunit *test)
 		data->version_mask = BIT(6) | BIT(5);
 	}
 
-	/* For cros_ec_get_host_command_version_mask() for host sleep v1. */
+	/* For get_host_command_version_mask() for host sleep v1. */
 	{
 		struct ec_response_get_cmd_versions *data;
 
@@ -288,7 +288,7 @@ static void cros_ec_proto_test_query_all_normal(struct kunit *test)
 		KUNIT_EXPECT_EQ(test, ec_dev->max_passthru, 0xbf - sizeof(struct ec_host_request));
 	}
 
-	/* For cros_ec_get_host_command_version_mask() for MKBP. */
+	/* For get_host_command_version_mask() for MKBP. */
 	{
 		struct ec_params_get_cmd_versions *data;
 
@@ -307,7 +307,7 @@ static void cros_ec_proto_test_query_all_normal(struct kunit *test)
 		KUNIT_EXPECT_EQ(test, ec_dev->mkbp_event_supported, 7);
 	}
 
-	/* For cros_ec_get_host_command_version_mask() for host sleep v1. */
+	/* For get_host_command_version_mask() for host sleep v1. */
 	{
 		struct ec_params_get_cmd_versions *data;
 
@@ -502,7 +502,7 @@ static void cros_ec_proto_test_query_all_no_mkbp(struct kunit *test)
 		KUNIT_ASSERT_PTR_NE(test, mock, NULL);
 	}
 
-	/* For cros_ec_get_host_command_version_mask() for MKBP. */
+	/* For get_host_command_version_mask() for MKBP. */
 	{
 		struct ec_response_get_cmd_versions *data;
 
@@ -543,7 +543,7 @@ static void cros_ec_proto_test_query_all_no_mkbp(struct kunit *test)
 		KUNIT_EXPECT_EQ(test, mock->msg.outsize, 0);
 	}
 
-	/* For cros_ec_get_host_command_version_mask() for MKBP. */
+	/* For get_host_command_version_mask() for MKBP. */
 	{
 		struct ec_params_get_cmd_versions *data;
 
@@ -596,7 +596,7 @@ static void cros_ec_proto_test_query_all_no_mkbp2(struct kunit *test)
 		KUNIT_ASSERT_PTR_NE(test, mock, NULL);
 	}
 
-	/* For cros_ec_get_host_command_version_mask() for MKBP. */
+	/* For get_host_command_version_mask() for MKBP. */
 	{
 		mock = cros_kunit_ec_xfer_mock_add(test, 0);
 		KUNIT_ASSERT_PTR_NE(test, mock, NULL);
@@ -632,7 +632,7 @@ static void cros_ec_proto_test_query_all_no_mkbp2(struct kunit *test)
 		KUNIT_EXPECT_EQ(test, mock->msg.outsize, 0);
 	}
 
-	/* For cros_ec_get_host_command_version_mask() for MKBP. */
+	/* For get_host_command_version_mask() for MKBP. */
 	{
 		struct ec_params_get_cmd_versions *data;
 
@@ -685,14 +685,14 @@ static void cros_ec_proto_test_query_all_no_host_sleep(struct kunit *test)
 		KUNIT_ASSERT_PTR_NE(test, mock, NULL);
 	}
 
-	/* For cros_ec_get_host_command_version_mask() for MKBP. */
+	/* For get_host_command_version_mask() for MKBP. */
 	{
 		mock = cros_kunit_ec_xfer_mock_add(test,
 						   sizeof(struct ec_response_get_cmd_versions));
 		KUNIT_ASSERT_PTR_NE(test, mock, NULL);
 	}
 
-	/* For cros_ec_get_host_command_version_mask() for host sleep v1. */
+	/* For get_host_command_version_mask() for host sleep v1. */
 	{
 		struct ec_response_get_cmd_versions *data;
 
@@ -733,7 +733,7 @@ static void cros_ec_proto_test_query_all_no_host_sleep(struct kunit *test)
 		KUNIT_EXPECT_EQ(test, mock->msg.outsize, 0);
 	}
 
-	/* For cros_ec_get_host_command_version_mask() for MKBP. */
+	/* For get_host_command_version_mask() for MKBP. */
 	{
 		mock = cros_kunit_ec_xfer_mock_next();
 		KUNIT_EXPECT_PTR_NE(test, mock, NULL);
@@ -745,7 +745,7 @@ static void cros_ec_proto_test_query_all_no_host_sleep(struct kunit *test)
 		KUNIT_EXPECT_EQ(test, mock->msg.outsize, sizeof(struct ec_params_get_cmd_versions));
 	}
 
-	/* For cros_ec_get_host_command_version_mask() for host sleep v1. */
+	/* For get_host_command_version_mask() for host sleep v1. */
 	{
 		mock = cros_kunit_ec_xfer_mock_next();
 		KUNIT_EXPECT_PTR_NE(test, mock, NULL);
@@ -793,14 +793,14 @@ static void cros_ec_proto_test_query_all_default_wake_mask(struct kunit *test)
 		KUNIT_ASSERT_PTR_NE(test, mock, NULL);
 	}
 
-	/* For cros_ec_get_host_command_version_mask() for MKBP. */
+	/* For get_host_command_version_mask() for MKBP. */
 	{
 		mock = cros_kunit_ec_xfer_mock_add(test,
 						   sizeof(struct ec_response_get_cmd_versions));
 		KUNIT_ASSERT_PTR_NE(test, mock, NULL);
 	}
 
-	/* For cros_ec_get_host_command_version_mask() for host sleep v1. */
+	/* For get_host_command_version_mask() for host sleep v1. */
 	{
 		mock = cros_kunit_ec_xfer_mock_add(test,
 						   sizeof(struct ec_response_get_cmd_versions));
@@ -844,7 +844,7 @@ static void cros_ec_proto_test_query_all_default_wake_mask(struct kunit *test)
 		KUNIT_EXPECT_EQ(test, mock->msg.outsize, 0);
 	}
 
-	/* For cros_ec_get_host_command_version_mask() for MKBP. */
+	/* For get_host_command_version_mask() for MKBP. */
 	{
 		mock = cros_kunit_ec_xfer_mock_next();
 		KUNIT_EXPECT_PTR_NE(test, mock, NULL);
@@ -856,7 +856,7 @@ static void cros_ec_proto_test_query_all_default_wake_mask(struct kunit *test)
 		KUNIT_EXPECT_EQ(test, mock->msg.outsize, sizeof(struct ec_params_get_cmd_versions));
 	}
 
-	/* For cros_ec_get_host_command_version_mask() for host sleep v1. */
+	/* For get_host_command_version_mask() for host sleep v1. */
 	{
 		mock = cros_kunit_ec_xfer_mock_next();
 		KUNIT_EXPECT_PTR_NE(test, mock, NULL);